package explicit;

public class BitString {

	private Integer index;
	private int size;
	
	public BitString(int index, int size)
	{
		this.index = index;
		this.size = size;
	}
	
	public boolean getBit(int index)
	{
		return (this.index & (1 << index)) == 0;
	}
	
	public void setBit(int index, boolean bit) 
	{
		if(bit) {
			index |= (1 << index);
		} else {
			index &=  ~(1 << index);
		}
	}
	
	public void increment()
	{
		index++;
	}
	
	public void decrement()
	{
		index--;
	}
	
	public BitString clone() 
	{
		return new BitString(index.intValue(), size);
	}
	
	public int getSize() 
	{
		return size;
	}
	
	public void divide(int value)
	{
		index /= value;
	}
	
	public void modulo(int value)
	{
		index %= value;
	}
	
	public void setSize(int size)
	{
		this.size = size;
	}
	
	public int intValue()
	{
		return index.intValue();
	}
}
