package prism;

import jdd.JDDNode;
import common.AbortComputationException;

public abstract class ECConsumer extends PrismComponent {
	protected NondetModel model;
	protected PrismComponent parent;

	public ECConsumer(PrismComponent parent, NondetModel model)
	{
		this.parent = parent;
		this.model = model;
	}

	/**
	 * Call-back function. Will be called upon discovery of a new maximal end component (MEC).
	 * <br>
	 * May throw an AbortComputationException to indicate that the computation
	 * of further MECs can be aborted.
	 * @param mec the set of states in the MEC.
	 **/
	public abstract void notifyNextMEC(JDDNode mec) throws PrismException, AbortComputationException;

	/**
	 * Call-back function. Will be called after MEC computation is complete.
	 */
	public void notifyDone() {}
	
	/**
	 * Call-back function. Will be called after MEC computation is aborted early (via an AbortComputationException).
	 */
	public void notifyAbort() {}

}
