package prism;

import java.util.ArrayList;
import java.util.List;

import jdd.JDD;
import jdd.JDDNode;

public class ECConsumerStore extends ECConsumer {

	private List<JDDNode> mecs = new ArrayList<JDDNode>();

	public ECConsumerStore(PrismComponent parent, NondetModel model) {
		super(parent, model);
	}

	@Override
	public void notifyNextMEC(JDDNode mec) {
		mecs.add(mec);
	}
	
	/**
	 * Get the list of states for computed MECs.
	 */
	public List<JDDNode> getMECStates() {
		return mecs;
	}
	
	public void clear()
	{
		for (JDDNode mec : mecs) {
			JDD.Deref(mec);
		}
		mecs.clear();
	}


}
