package visualisation;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class JSONAlgorithmStep
{
	public List<JSONAlgorithmAction> actions = new ArrayList<JSONAlgorithmAction>();

	public void add(JSONAlgorithmAction... actions)
	{
		this.actions.addAll(Arrays.asList(actions));
	}
	
	
	public void toJSON(StringBuffer sb)
	{
		sb.append("{ actions : [ ");

		for (JSONAlgorithmAction action : actions) {
			action.toJSON(sb);
			sb.append(", ");
		}

		sb.append(" ] }");
	}

	public void addExplanation(String explanation)
	{
		// TODO: quote properly
		actions.add(new JSONAlgorithmAction("explain_append", "\"" + explanation + "\""));
	}

	public void addExplanationHTML(String explanation)
	{
		// TODO: quote properly
		actions.add(new JSONAlgorithmAction("explain_append_html", "\"" + explanation + "\""));
	}

}
